
#property copyright " "
#property link      " "

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 ForestGreen
#property indicator_color2 Red
#property indicator_color3 Aqua
#property indicator_color4 Yellow
#property indicator_color5 Blue
#property indicator_color6 Gold

extern int g_period_76 = 2;
extern int gi_80 = 1;
double gd_84 = 1.0;
int gi_92 = 1;
int gi_96 = 1;
extern int Nbars = 1000;
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
double g_ibuf_116[];
double g_ibuf_120[];
double g_ibuf_124[];
extern bool SoundON = FALSE;
bool gi_132 = FALSE;
bool gi_136 = FALSE;

int init() {
   SetIndexBuffer(0, g_ibuf_104);
   SetIndexBuffer(1, g_ibuf_108);
   SetIndexBuffer(2, g_ibuf_112);
   SetIndexBuffer(3, g_ibuf_116);
   SetIndexBuffer(4, g_ibuf_120);
   SetIndexBuffer(5, g_ibuf_124);
   SetIndexStyle(0, DRAW_NONE, STYLE_SOLID, 1);
   SetIndexStyle(1, DRAW_NONE, STYLE_SOLID, 1);
   SetIndexStyle(2, DRAW_ARROW, STYLE_SOLID);
   SetIndexStyle(3, DRAW_ARROW, STYLE_SOLID);
   SetIndexStyle(4, DRAW_NONE,STYLE_DOT);
   SetIndexStyle(5, DRAW_NONE,STYLE_DOT);
   SetIndexArrow(0, 159);
   SetIndexArrow(1, 159);
   SetIndexArrow(2, 233);
   SetIndexArrow(3, 234);
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS));
   string ls_0 = "My Entry Trigger(" + g_period_76 + "," + gi_80 + ")";
   IndicatorShortName(ls_0);
   SetIndexLabel(0, "UpTrend Stop");
   SetIndexLabel(1, "DownTrend Stop");
   SetIndexLabel(2, "UpTrend Signal");
   SetIndexLabel(3, "DownTrend Signal");
   SetIndexLabel(4, "UpTrend Line");
   SetIndexLabel(5, "DownTrend Line");
   SetIndexDrawBegin(0, g_period_76);
   SetIndexDrawBegin(1, g_period_76);
   SetIndexDrawBegin(2, g_period_76);
   SetIndexDrawBegin(3, g_period_76);
   SetIndexDrawBegin(4, g_period_76);
   SetIndexDrawBegin(5, g_period_76);
   return (0);
}

int start() {
   int li_8;
   double lda_12[25000];
   double lda_16[25000];
   double lda_20[25000];
   double lda_24[25000];
   for (int l_shift_4 = Nbars; l_shift_4 >= 0; l_shift_4--) {
      g_ibuf_104[l_shift_4] = 0;
      g_ibuf_108[l_shift_4] = 0;
      g_ibuf_112[l_shift_4] = 0;
      g_ibuf_116[l_shift_4] = 0;
      g_ibuf_120[l_shift_4] = EMPTY_VALUE;
      g_ibuf_124[l_shift_4] = EMPTY_VALUE;
   }
   for (l_shift_4 = Nbars - g_period_76 - 1; l_shift_4 >= 0; l_shift_4--) {
      lda_12[l_shift_4] = iBands(NULL, 0, g_period_76, gi_80, 0, PRICE_CLOSE, MODE_UPPER, l_shift_4);
      lda_16[l_shift_4] = iBands(NULL, 0, g_period_76, gi_80, 0, PRICE_CLOSE, MODE_LOWER, l_shift_4);
      if (Close[l_shift_4] > lda_12[l_shift_4 + 1]) li_8 = 1;
      if (Close[l_shift_4] < lda_16[l_shift_4 + 1]) li_8 = -1;
      if (li_8 > 0 && lda_16[l_shift_4] < lda_16[l_shift_4 + 1]) lda_16[l_shift_4] = lda_16[l_shift_4 + 1];
      if (li_8 < 0 && lda_12[l_shift_4] > lda_12[l_shift_4 + 1]) lda_12[l_shift_4] = lda_12[l_shift_4 + 1];
      lda_20[l_shift_4] = lda_12[l_shift_4] + (gd_84 - 1.0) / 2.0 * (lda_12[l_shift_4] - lda_16[l_shift_4]);
      lda_24[l_shift_4] = lda_16[l_shift_4] - (gd_84 - 1.0) / 2.0 * (lda_12[l_shift_4] - lda_16[l_shift_4]);
      if (li_8 > 0 && lda_24[l_shift_4] < lda_24[l_shift_4 + 1]) lda_24[l_shift_4] = lda_24[l_shift_4 + 1];
      if (li_8 < 0 && lda_20[l_shift_4] > lda_20[l_shift_4 + 1]) lda_20[l_shift_4] = lda_20[l_shift_4 + 1];
      if (li_8 > 0) {
         if (gi_92 > 0 && g_ibuf_104[l_shift_4 + 1] == -1.0) {
            g_ibuf_112[l_shift_4] = Low[l_shift_4]-5*Point;
            g_ibuf_104[l_shift_4] = lda_24[l_shift_4];
            if (gi_96 > 0) g_ibuf_120[l_shift_4] = lda_24[l_shift_4];
            if (SoundON == TRUE && l_shift_4 == 0 && !gi_132) {
               Alert("My Entry Trigger Alert UP on", Symbol(), "-", Period());
               gi_132 = TRUE;
               gi_136 = FALSE;
            }
         } else {
            g_ibuf_104[l_shift_4] = lda_24[l_shift_4];
            if (gi_96 > 0) g_ibuf_120[l_shift_4] = lda_24[l_shift_4];
            g_ibuf_112[l_shift_4] = -1;
         }
         if (gi_92 == 2) g_ibuf_104[l_shift_4] = 0;
         g_ibuf_116[l_shift_4] = -1;
         g_ibuf_108[l_shift_4] = -1.0;
         g_ibuf_124[l_shift_4] = EMPTY_VALUE;
      }
      if (li_8 < 0) {
         if (gi_92 > 0 && g_ibuf_108[l_shift_4 + 1] == -1.0) {
            g_ibuf_116[l_shift_4] = High[l_shift_4]+5*Point;
            g_ibuf_108[l_shift_4] = lda_20[l_shift_4];
            if (gi_96 > 0) g_ibuf_124[l_shift_4] = lda_20[l_shift_4];
            if (SoundON == TRUE && l_shift_4 == 0 && !gi_136) {
               Alert("My Entry Trigger Alert DOWN on", Symbol(), "-", Period());
               gi_136 = TRUE;
               gi_132 = FALSE;
            }
         } else {
            g_ibuf_108[l_shift_4] = lda_20[l_shift_4];
            if (gi_96 > 0) g_ibuf_124[l_shift_4] = lda_20[l_shift_4];
            g_ibuf_116[l_shift_4] = -1;
         }
         if (gi_92 == 2) g_ibuf_108[l_shift_4] = 0;
         g_ibuf_112[l_shift_4] = -1;
         g_ibuf_104[l_shift_4] = -1.0;
         g_ibuf_120[l_shift_4] = EMPTY_VALUE;
      }
   }
   return (0);
}